import { zodResolver } from '@hookform/resolvers/zod'
import { data } from 'react-router'
import { getValidatedFormData } from 'remix-hook-form'
import { XiorError } from 'xior'

import { createNewsRequest } from '~/apis/admin/create-news'
import { handleCookie } from '~/libs/cookies'
import { contentSchema, type TContentSchema } from '~/pages/contents-create'

import type { Route } from './+types/actions.register'

export const action = async ({ request }: Route.ActionArgs) => {
  const { staffToken } = await handleCookie(request)
  try {
    const {
      errors,
      data: payload,
      receivedValues: defaultValues,
    } = await getValidatedFormData<TContentSchema>(
      request,
      zodResolver(contentSchema),
      false,
    )

    if (errors) {
      return data({ success: false, errors, defaultValues }, { status: 400 })
    }

    const { data: newsData } = await createNewsRequest({
      accessToken: staffToken,
      payload,
    })

    return data(
      {
        success: true,
        newsData,
      },
      {
        status: 200,
        statusText: 'OK',
      },
    )
  } catch (error) {
    if (error instanceof XiorError) {
      return data(
        {
          success: false,
          message: error?.response?.data?.error?.message || error.message,
        },
        {
          status: error?.response?.status || 500,
        },
      )
    }
    return data(
      {
        success: false,
        message: 'Internal server error',
      },
      { status: 500 },
    )
  }
}
